package fr.iut.mapping.database

import android.content.Context
import androidx.room.Database
import androidx.room.Room
import androidx.room.RoomDatabase
import fr.iut.mapping.database.DAO.RestaurantDAO
import fr.iut.mapping.database.Entity.RestaurantEntity

@Database(entities = arrayOf(RestaurantEntity::class), version = 1, exportSchema = false)
abstract class RestaurantDatabase : RoomDatabase() {

    abstract fun restaurantDAO(): RestaurantDAO

    companion object {
        @Volatile
        private var INSTANCE: RestaurantDatabase? = null

        fun getDatabase(context: Context): RestaurantDatabase {
            return INSTANCE ?: synchronized(this) {
                val instance = Room.databaseBuilder(
                    context.applicationContext, RestaurantDatabase::class.java, "restaurant_database"
                ).build()
                INSTANCE = instance
                instance
            }
        }
    }


}
